diff --git a/libswresample/resample.c b/libswresample/resample.c
index 17cebad01b..89859dec79 100644
--- a/libswresample/resample.c
+++ b/libswresample/resample.c
@@ -356,26 +356,7 @@ static int multiple_resample(ResampleContext *c, AudioData *dst, int dst_size, A
 
     *consumed = 0;
 
-    if (c->filter_length == 1 && c->phase_count == 1) {
-        int64_t index2= (1LL<<32)*c->frac/c->src_incr + (1LL<<32)*c->index + 1;
-        int64_t incr= (1LL<<32) * c->dst_incr / c->src_incr + 1;
-        int new_size = (src_size * (int64_t)c->src_incr - c->frac + c->dst_incr - 1) / c->dst_incr;
-
-        dst_size = FFMAX(FFMIN(dst_size, new_size), 0);
-        if (dst_size > 0) {
-            for (i = 0; i < dst->ch_count; i++) {
-                c->dsp.resample_one(dst->ch[i], src->ch[i], dst_size, index2, incr);
-                if (i+1 == dst->ch_count) {
-                    c->index += dst_size * c->dst_incr_div;
-                    c->index += (c->frac + dst_size * (int64_t)c->dst_incr_mod) / c->src_incr;
-                    av_assert2(c->index >= 0);
-                    *consumed = c->index;
-                    c->frac   = (c->frac + dst_size * (int64_t)c->dst_incr_mod) % c->src_incr;
-                    c->index = 0;
-                }
-            }
-        }
-    } else {
+    {
         int64_t end_index = (1LL + src_size - c->filter_length) * c->phase_count;
         int64_t delta_frac = (end_index - c->index) * c->src_incr - c->frac;
         int delta_n = (delta_frac + c->dst_incr - 1) / c->dst_incr;
@@ -386,8 +367,12 @@ static int multiple_resample(ResampleContext *c, AudioData *dst, int dst_size, A
         if (dst_size > 0) {
             /* resample_linear and resample_common should have same behavior
              * when frac and dst_incr_mod are zero */
-            resample_func = (c->linear && (c->frac || c->dst_incr_mod)) ?
-                            c->dsp.resample_linear : c->dsp.resample_common;
+            if (c->filter_length == 1 && c->phase_count == 1)
+                resample_func = c->dsp.resample_one;
+            else if (c->linear && (c->frac || c->dst_incr_mod))
+                resample_func = c->dsp.resample_linear;
+            else
+                resample_func = c->dsp.resample_common;
             for (i = 0; i < dst->ch_count; i++)
                 *consumed = resample_func(c, dst->ch[i], src->ch[i], dst_size, i+1 == dst->ch_count);
         }
diff --git a/libswresample/resample.h b/libswresample/resample.h
index 1731dad3cf..8cc29effe8 100644
--- a/libswresample/resample.h
+++ b/libswresample/resample.h
@@ -51,8 +51,8 @@ typedef struct ResampleContext {
     int phase_count_compensation;      /* desired phase_count when compensation is enabled */
 
     struct {
-        void (*resample_one)(void *dst, const void *src,
-                             int n, int64_t index, int64_t incr);
+        int (*resample_one)(struct ResampleContext *c, void *dst,
+                            const void *src, int n, int update_ctx);
         int (*resample_common)(struct ResampleContext *c, void *dst,
                                const void *src, int n, int update_ctx);
         int (*resample_linear)(struct ResampleContext *c, void *dst,
diff --git a/libswresample/resample_template.c b/libswresample/resample_template.c
index 4c227b9940..a8114ea918 100644
--- a/libswresample/resample_template.c
+++ b/libswresample/resample_template.c
@@ -72,17 +72,27 @@
 
 #endif
 
-static void RENAME(resample_one)(void *dest, const void *source,
-                                 int dst_size, int64_t index2, int64_t incr)
+static int RENAME(resample_one)(ResampleContext *c,
+                                void *dest, const void *source,
+                                int dst_size, int update_ctx)
 {
     DELEM *dst = dest;
     const DELEM *src = source;
     int dst_index;
+    int64_t index2 = (1LL << 32) * c->frac     / c->src_incr + 1 + (1LL << 32) * c->index;
+    int64_t incr   = (1LL << 32) * c->dst_incr / c->src_incr + 1;
 
     for (dst_index = 0; dst_index < dst_size; dst_index++) {
         dst[dst_index] = src[index2 >> 32];
         index2 += incr;
     }
+
+    if (update_ctx) {
+        c->frac  = (c->frac + dst_size * (int64_t)c->dst_incr_mod) % c->src_incr;
+        c->index = 0;
+    }
+
+    return index2 >> 32;
 }
 
 static int RENAME(resample_common)(ResampleContext *c,